// This package name is required by Major!
package major.mutation;

import java.util.*;

/**
 * A simple driver class for Major --
 * this class name is required by Major!
 */
public class Config {

    /*
     * The mutant identifier:
     *
     * __M_NO <  0 -> Run original version
     *
     * __M_NO == 0 -> Run original version and gather coverage information
     *
     * __M_NO >  0 -> Execute mutant with the corresponding id
     */
    public static int __M_NO = -1;

    // Set to store IDs of covered mutants
    public static BitSet covSet = new BitSet();

    // The coverage method is called if and only if the
    // mutant identifier is set to 0!
    public static boolean COVERED(int from, int to) {
        synchronized (covSet) {
            covSet.set(from, to + 1);
        }
        // Always return false as required by
        // Conditional Mutation!
        return false;
    }

    /*
     * Additional methods for the mutation analysis back-end
     */
    // Reset the coverage information
    public static void reset() {
        synchronized (covSet) {
            covSet.clear();
        }
    }

    // Get list of all covered mutants
    public static List<Integer> getCoverageList() {
        synchronized (covSet) {
            List<Integer> covList = new ArrayList<>(covSet.cardinality());
            for (int i = covSet.nextSetBit(0); i >= 0; i = covSet.nextSetBit(i+1)) {
                covList.add(i);
            }

            return covList;
        }
    }
}
